<template>
  <section class="container">
    <div class="card">
      <VInput
        v-model="cep"
        v-mask="'#####-###'"
        placeholder="Digite o CEP"
        large
      />
      <VBtn
        large
        dark
        @click="submit"
      >
        Buscar CEP
      </VBtn>
    </div>
    <Transition name="fade">
      <div
        v-if="show"
        class="card"
        style="margin-top: 24px"
      >
        <template v-if="response.hasOwnProperty('cep')">
          <p>
            <b>CEP:</b> {{ response.cep }}
          </p>
          <p>
            <b>Estado:</b> {{ response.uf }}
          </p>
          <p>
            <b>Cidade:</b> {{ response.localidade }}
          </p>
          <p>
            <b>Logradouro:</b> {{ response.logradouro }}
          </p>
        </template>
        <template v-else>
          <p style="color: #d44950">
            {{ response }}
          </p>
        </template>
      </div>
    </Transition>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'nuxt-property-decorator';

// Query
import qCep from '@/graphql/qCep.gql';

const { mask } = require('vue-the-mask');

@Component({
  components: {
    VInput: () => import('@/components/core/v-input.vue'),
    VBtn: () => import('@/components/core/v-btn.vue'),
  },
  directives: {
    mask,
  },
})
export default class Index extends Vue {
  cep = ''

  show = false

  response = {}

  async submit() {
    try {
      this.show = false;

      const { data } = await this.$apollo.query({
        query: qCep,
        variables: {
          number: this.cep.replace(/-/g, ''),
        },
      });

      this.response = data.cep;
      this.show = true;
    } catch (e) {
      this.response = e.message;
      this.show = true;
    }
  }

  @Watch('cep')
  changeCep(val: string) {
    if (val.length === 0) this.show = false;
  }
}
</script>

<style lang="stylus">
.container
  margin 0 auto
  min-height 100vh
  display flex
  flex-direction column
  justify-content center
  align-items center
  text-align center

.card
  position relative
  text-align left
  min-width 0
  padding 24px
  background-color white
  border 1px solid rgba(black, .125)
  border-radius 6px

// Transition Vue
.fade-enter-active,
.fade-leave-active
  transition opacity .5s

.fade-enter,
.fade-leave-to
  opacity 0
</style>
